;     
;        ,   
;    c:pt_starter,    
(if pt_starter ;   
  (progn
    (setq pt_root (strcat (vl-filename-directory pt_starter) "/"))
    (setcfg "AppData/pt/root" pt_root)
    (setq pt_starter nil) ;  
    )
  (setq pt_root (getcfg "AppData/pt/root")))

(while
  (not (and pt_root (vl-file-size (strcat pt_root "pt_starter.lsp"))))
  (setq pt_root (strcat (vl-filename-directory (getfiled "  pt_starter.lsp" "" "" 2)) "/"))
  (setcfg "AppData/pt/root" pt_root))

(setq pt_commands nil)
(setq pt_commands_settings nil)

;_    -
(defun declare (name comment)
  (setq pt_commands
        (cons (list name comment pt-now-loading)
              pt_commands)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;   
(defun declare-setting (name comment default)
  (setq pt_settings (cons (list name comment default) pt_settings))
  (use-setting name))

;      
(defun use-setting (name)
  (setq
    pt_commands 
    (cons
      (append (car pt_commands) (list name))
      (cdr pt_commands))))

;     
(defun declare-description (descr)
	; TODO 
	;     
	(setq descr nil))

(setq last_time nil)
(setq start_time (getvar "MILLISECS"))
(setq pt_load_failure nil)
;    pt_key
(setq pt_key (getcfg "AppData/pt/key"))
(princ "\n")

(defun timestamp (x) 'timestamp)

;   ,     "pt_*.lsp"
(foreach
  file
  (vl-remove
    "pt_starter.lsp" ;   
    (append
      (vl-directory-files pt_root "pt_*.lsp")
      (vl-directory-files pt_root "pt_*.des")
      (vl-directory-files pt_root "pt_*.fas")))
  (princ (strcat file ": "))
  (setq pt-now-loading (vl-filename-base file))
  (load (strcat pt_root file))
  ;(princ (strcat "loaded file: " file "\n"))
  (princ "\n"))

;      
(declare "pt_starter" "   ")
(declare-setting "STARTER_LIST_WIDTH" "   " "150")
(declare-setting "STARTER_LIST_HEIGHT" "   " "45")
(declare-setting "STARTER_LIST_TABS" "     " "16")

;       ,  
(setq pt_commands (vl-sort pt_commands
                           '(lambda (a1 a2) (< (car a1) (car a2)))))

(if pt_load_failure
	(setq pt_commands
				(cons
					(list "-------" "-------" "-------")
					(cons (list "pt-lic" "   .         ." "-------")
								(cons
									(list "-------" "-------" "-------")
									pt_commands)))))

(setq pt_last_commands nil)
(setq PT_LC_AMOUNT 15) ;     

(timestamp "primitive tools  ")

(setq pt_loaded T)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;   
(defun c:pt_reload ()
  (load (strcat pt_root "pt_starter.lsp")))

(defun c:pt_starter ( / pt_dialogue_result whole-list)
	;      
	;   ,  ,  
	(changefile (strcat pt_root "pt_runapp.dcl")
							(list ;    
								(list "width=*" (strcat "width=" (pt:settings "STARTER_LIST_WIDTH" "R" "150") ";"))
								(list "height=*" (strcat "height=" (pt:settings "STARTER_LIST_HEIGHT" "R" "50") ";"))
								(list "tabs=*" (strcat "tabs=" (pt:settings "STARTER_LIST_TABS" "R" "15") ";" ))))
	(setq pt_dialogue_result
				(pt:chooser "Choose script to launch"
										"pt_runapp.dcl"
										(mapcar '(lambda (x)
															 (strcat (car x) "\t" 
																			 ((lambda (y)
																					(if (listp y) (car y) y))
																				(cadr x))))
														(setq whole-list
																	(append (if pt_last_commands
																						(append
																							pt_last_commands
																							'(("" ""))
																							))
																					pt_commands)))))

	(if pt_dialogue_result
		(progn
			(setq pt_command (car (nth (atoi pt_dialogue_result) whole-list)))
			(varlog "pt_command" pt_command)
			(if (= "*" (substr pt_command 1 1))
				(command (substr pt_command 2))
				(vla-SendCommand (vla-get-activedocument (vlax-get-acad-object)) (strcat pt_command "\n")))))
	;   ,       
	;  :   ,     
	; ,  ,     
	;  ,      
	;      ,   
	(if pt_command
		((lambda (cmd)
			 (if (member cmd pt_last_commands) 
				 (setq pt_last_commands
							 (cons cmd (vl-remove cmd pt_last_commands)))
				 (setq pt_last_commands
							 (cut PT_LC_AMOUNT 
										(cons cmd pt_last_commands)))))
		 (assoc pt_command pt_commands)))
	(princ))
'r
